#    Copyright (c) 2013 Mirantis, Inc.
#
#    Licensed under the Apache License, Version 2.0 (the "License"); you may
#    not use this file except in compliance with the License. You may obtain
#    a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#    License for the specific language governing permissions and limitations
#    under the License.

import gettext
import sys
import pkg_resources

gettext.install('muranoapi', './muranoapi/locale', unicode=1)


from pbr import version
__version_info = version.VersionInfo('murano-api')
__version__ = __version_info.cached_version_string()


def replace_dist(requirement):
    """
    If there is a conflicting egg module,
    i.e. an older standard system module installed,
    then replace it with this requirement
    """
    try:
        return pkg_resources.require(requirement)
    except pkg_resources.VersionConflict:
        e = sys.exc_info()[1]
        dist = e.args[0]
        req = e.args[1]
        if dist.key == req.key:
            del pkg_resources.working_set.by_key[dist.key]
            # We assume there is no need to adjust sys.path
            # and the associated pkg_resources.working_set.entries
            try:
                return pkg_resources.require(requirement)
            except pkg_resources.DistributionNotFound:
                print 'Not found, skipping', requirement
                return {}

replace_dist("Routes == 1.13")
